﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Programmable {
  [Item("Encoding", "Base class for describing different encodings.")]
  [StorableClass]
  public abstract class Encoding : NamedItem {
    public override bool CanChangeName {
      get { return false; }
    }

    [StorableConstructor]
    protected Encoding(bool deserializing) : base(deserializing) { }
    protected Encoding(Encoding original, Cloner cloner)
      : base(original, cloner) { }
    protected Encoding(string name) : base(name) { }


    public event EventHandler ParameterConfigurationChanged;
    protected virtual void OnParameterConfigurationChanged() {
      var handler = ParameterConfigurationChanged;
      if (handler != null) handler(this, EventArgs.Empty);
    }
  }
}
